<template>
  <div class="wrapper">
    <h6>{{ $t('components.loader.description') }}</h6>
    <div class="row">
      <div class="col">
        <div class="custom-file">
          <input @change="fileIsSelected" :accept="allowedExtentions" type="file" class="custom-file-input" id="customFile">
          <label class="custom-file-label" for="customFile">
            <span v-if="!selectedFile">{{ $t('components.loader.fileInputPlaceholder') }}</span>
            <span v-else>{{ selectedFile.name }}</span>
          </label>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col">
        <button @click="startFileUpload" class="btn btn-success btn-sm">{{ $t('button.upload') }}</button>
      </div>
    </div>
  </div>
</template>

<script>
import { ALLOWED_DATA_TYPES } from '@/lib'
import { EventBus } from '@/bus'

export default {
  name: 'Loader',
  data () {
    return {
      selectedFile: null,
      selectedFileType: null
    }
  },
  computed: {
    /**
     * Create string of allowed file extentions
     */
    allowedExtentions () {
      let exts = ALLOWED_DATA_TYPES.map(value => {
        return '.' + value
      })
      return exts.join(',').toLowerCase()
    },

    /**
     * Create new Regexp pattern from allowed types
     */
    typesPattern () {
      let exts = ALLOWED_DATA_TYPES.join('|').toLowerCase()
      return new RegExp('(' + exts + ')', 'i')
    }
  },
  methods: {
    /**
     * Set selected file and type
     * @param { Event } event - change event
     */
    fileIsSelected (event) {
      let file = event.target.files[0]
      let isValidFile = this.isValidFile(file)
      this.selectedFile = (isValidFile) ? file : null
      this.selectedFileType = (isValidFile) ? this.getFileTypeByMime(file.type) : null
    },

    /**
     * Validate file
     * @param { File } file - file object
     */
    isValidFile (file) {
      return ((file instanceof File) && this.typesPattern.test(file.type))
    },

    /**
     * Get file type from MIME-type string by regex pattern
     * @param { String } mimeType - MIME type
     */
    getFileTypeByMime (mimeType) {
      let matched = mimeType.match(this.typesPattern)
      return (matched != null) ? matched[0] : matched
    },

    /**
     * Start upload selected file context
     */
    startFileUpload () {
      const freader = new FileReader()
      if (this.selectedFile != null && this.selectedFileType != null) {
        // Start read file context
        freader.readAsText(this.selectedFile)

        // Result of reading
        freader.onload = event => {
          let context = event.target.result

          // Broadcast event
          EventBus.$emit('content:loaded', context, this.selectedFileType)

          // Clear selected file
          this.clearSelected()
        }
      }
    },

    /**
     * Clear selected
     */
    clearSelected () {
      this.selectedFile = null
      this.selectedFileType = null
    }
  }
}
</script>

<style lang="scss" scoped>
  .row {
    padding-bottom: 10px;
  }
</style>
